<template>
	<view class="container">
		<view class="bg u-absolute" style="width: 100%;height: 100%;overflow: hidden;top: 0;">
			<u-image  src="../../static/images/i_bg.png" style="width: 100%;height:100%" mode=""></u-image>
		</view>
		<view class="wrapper u-relative" style="padding-top: 48rpx;box-sizing: border-box;">
			<view class="input-content">
				<view style="font-size: 58rpx;font-weight: bold;color: #333;margin-bottom: 48rpx;">注册</view>

				<view class="cu-form-group">
					<view class="title">手机号</view>
					<input  class="input" type="number" :value="mobile" placeholder="请输入手机号" maxlength="11" data-key="mobile"
						@input="inputChange" />
				</view>
				<view class="cu-form-group">
					<text class="title">验证码</text>
					<view class="input flex">
						<input type="number" :value="code" placeholder="请输入验证码" maxlength="6" data-key="code"
						@input="inputChange" @confirm="toLogin" />
						<button class="send-msg" @click="sendMsg" :disabled="sending">{{ sendTime }}</button>
					</view>
				</view>

				<view class="cu-form-group">
					<text class="title">设置密码</text>
					<input class="input" type="password" :value="password" placeholder="请设置新密码" placeholder-class="input-empty"
						maxlength="20" minlength="6" data-key="password" @input="inputChange" @confirm="toLogin" />
				</view>
				<!-- <view class="cu-form-group"
					style="border: 2upx solid whitesmoke;margin-bottom: 20px;border-radius: 30px">
					<text class="title">邀请码</text>
					<input type="text" v-if="registerCode == '是'" :value="invitation" placeholder="请填写邀请码"
						data-key="invitation" maxlength="20" @input="inputChange" @confirm="toLogin" />
					<input type="text" v-if="registerCode == '否'" :value="invitation" placeholder="请填写邀请码(选填)"
						data-key="invitation" maxlength="20" @input="inputChange" @confirm="toLogin" />
				</view> -->
				<button class="confirm-btn" @click="toLogin">注册</button>
			</view>
			<view class="footer">
				<text @tap="isShowAgree" class="cuIcon"
					:class="showAgree ? 'cuIcon-radiobox' : 'cuIcon-round'">注册即同意</text>
				<!-- 协议地址 -->
				<navigator url="/me/setting/mimi" open-type="navigate" style="color: #37A6FF;">《隐私政策》</navigator>
				与
				<navigator url="/me/setting/xieyi" open-type="navigate" style="color: #37A6FF;">《用户协议》</navigator>
			</view>
		</view>
	</view>
</template>

<script>
	export default {
		data() {
			return {
				showAgree: false,
				code: '',
				mobile: '',
				password: '',
				sending: false,
				sendTime: '获取验证码',
				count: 60,
				relation: "",
				invitation: '',
				registerCode: '',
				qdCodeion: '', //渠道码
			};
		},
		onLoad() {
			if (uni.getStorageSync('qdCodeion')) {
				this.qdCodeion = uni.getStorageSync('qdCodeion')
			}
			let relation = uni.getStorageSync('invitation')
			if (relation) {
				this.relation = relation;
				this.invitation = relation;
			}
			this.$u.get('/app/common/type/3').then(res => {
				if (res.code == 0) {
					this.registerCode = res.data.value
				}
			});
		},
		methods: {
			isShowAgree() {
				//是否选择协议
				this.showAgree = !this.showAgree;
			},
			showMa() {
				//查询官方邀请码
				this.$Request.getT('/common/type/88').then(res => {
					if (res.code == 0) {
						this.invitation = res.data.value;
					}
				});
			},
			sendMsg() {
				const {
					mobile
				} = this;
				if (!mobile) {
					uni.showToast({
						title: '请输入手机号',
						icon: 'none',
						duration: 1000
					})
				} else if (mobile.length !== 11) {
					uni.showToast({
						title: '请输入正确的手机号',
						icon: 'none',
						duration: 1000
					})
				} else {
					uni.showLoading({
						title: '正在发送验证码...'
					})
					this.$u.get('/app/Login/sendMsg/' + mobile + '/login').then(res => {
						if (res.code === 0) {
							this.sending = true;
							uni.showToast({
								title: '验证码发送成功请注意查收',
								icon: 'none',
								duration: 1000
							})
							this.countDown();
							uni.hideLoading();
						} else {
							uni.hideLoading();
							uni.showModal({
								showCancel: false,
								title: '短信发送失败',
								content: res.msg ? res.msg : '请一分钟后再获取验证码'
							});
						}
					});
				}
			},
			countDown() {
				const {
					count
				} = this;
				if (count === 1) {
					this.count = 60;
					this.sending = false;
					this.sendTime = '获取验证码';
				} else {
					this.count = count - 1;
					this.sending = true;
					this.sendTime = count - 1 + '秒后重新获取';
					setTimeout(this.countDown.bind(this), 1000);
				}
			},
			inputChange(e) {
				const key = e.currentTarget.dataset.key;
				this[key] = e.detail.value;
			},
			navBack() {
				uni.navigateBack();
			},

			navTo(url) {
				uni.navigateTo({
					url
				});
			},
			toLogin() {
				const {
					mobile,
					password,
					code,
					showAgree,
					invitation,
					registerCode,
					qdCodeion
				} = this;
				if (!mobile) {
					uni.showToast({
						title: '请输入账号',
						icon: 'none',
						duration: 1000
					})
					return
				}
				if (!code) {
					uni.showToast({
						title: '请输入验证码',
						icon: 'none',
						duration: 1000
					})
					return
				}
				if (!password) {
					uni.showToast({
						title: '请设置密码',
						icon: 'none',
						duration: 1000
					})
					return
				}
				if (password.length < 6) {
					uni.showToast({
						title: '密码位数必须大于六位',
						icon: 'none',
						duration: 1000
					})
					return
				}
				if (invitation.length == 0 && registerCode == '是') {
					uni.showToast({
						title: '请输入邀请码',
						icon: 'none',
						duration: 1000
					})
					return
				}
				if (!showAgree) {
					uni.showToast({
						title: '请先同意《隐私政策》和《用户协议》',
						icon: 'none',
						duration: 1000
					})
					return
				}
				this.logining = true;
				uni.showLoading({
					title: '注册中...'
				})
				let platform = ''
				// #ifdef APP
				platform = 'app'
				// #endif
				// #ifdef H5
				platform = 'h5'
				// #endif
				this.$u.post('/app/Login/registerCode?password=' + password + '&phone=' + mobile + '&msg=' + code +
					'&inviterCode=' + invitation + '&platform=' + platform + '&qdCode=' + qdCodeion).then(res => {
					if (res.code === 0) {
						// this.$queue.remove('invitation');
						uni.setStorageSync('token', res.token)
						uni.setStorageSync('userId', res.user.userId)
						uni.setStorageSync('phone', res.user.phone)
						uni.setStorageSync('invitationCode', res.user.invitationCode)
						//设置渠道码
						if (res.user.qdCod) {
							uni.setStorageSync('qdCod', res.user.qdCod)
						}

						uni.showToast({
							title: '注册成功',
							icon: 'none'
						})
						setTimeout(function() {
							uni.switchTab({
								url: '/pages/index/index'
							});
						}, 1000)
						// this.getUserInfo(res.userId, res.token);
					} else {
						uni.hideLoading();
						uni.showModal({
							showCancel: false,
							title: '注册失败',
							content: res.msg
						});
					}
				});
			},
			getUserInfo(userId, token) {
				this.$u.api.userinfo().then(res => {
					if (res.code === 0) {
						// #ifdef APP-PLUS
						if (uni.getSystemInfoSync().platform == "android") {
							let clientid = plus.push.getClientInfo().clientid;
							this.$Request.postT('/appLogin/updateClientId?clientId=' + clientid + '&userId=' +
								userId).then(res => {

							});
						}
						// #endif
						uni.setStorageSync('image_url', res.data.imageUrl ? res.data.imageUrl :
							'/static/img/common/logo.jpg')
						uni.setStorageSync('relation_id', res.data.relationId)
						uni.setStorageSync('relation', res.data.invitationCode)
						uni.setStorageSync('grade', res.data.grade)
						uni.setStorageSync('phone', res.data.phone)
						uni.setStorageSync('token', res.token)
						uni.setStorageSync('userId', res.data.userId)
						uni.setStorageSync('isInvitation', res.data.isInvitation)
						uni.setStorageSync('userName', res.data.userName ? res.data.userName : res.data.phone)

						// this.$queue.setData('image_url', res.data.imageUrl ? res.data.imageUrl : '/static/img/common/logo.jpg');
						// this.$queue.setData('relation_id', res.data.relationId);
						// this.$queue.setData('relation', res.data.invitationCode);
						// this.$queue.setData('grade', res.data.grade);
						// this.$queue.setData('mobile', res.data.mobile);
						// this.$queue.setData('isInvitation', res.data.isInvitation);
						// this.$queue.setData('nickName', res.data.nickName ? res.data.nickName : res.data.phone);
						// this.$queue.setData('gender', parseInt(res.data.gender));
						uni.switchTab({
							url: '/pages/index/index'
						});
					} else {
						uni.showModal({
							showCancel: false,
							title: '登录失败',
							content: res.msg
						});
						this.$queue.logout();
					}
					uni.hideLoading();
				})
				// this.$Request.postJson('/app/selectUserById?userId=' + userId).then(res => {
				// 	if (res.code === 0) {
				// 		// #ifdef APP-PLUS
				// 		if (uni.getSystemInfoSync().platform == "android") {
				// 			let clientid = plus.push.getClientInfo().clientid;
				// 			this.$Request.postT('/appLogin/updateClientId?clientId=' + clientid + '&userId=' + userId).then(res => {

				// 			});
				// 		}
				// 		// #endif
				// 		this.$queue.setData('image_url', res.data.imageUrl ? res.data.imageUrl : '/static/img/common/logo.jpg');
				// 		this.$queue.setData('relation_id', res.data.relationId);
				// 		this.$queue.setData('relation', res.data.invitationCode);
				// 		this.$queue.setData('grade', res.data.grade);
				// 		this.$queue.setData('mobile', res.data.mobile);
				// 		this.$queue.setData('isInvitation', res.data.isInvitation);
				// 		this.$queue.setData('nickName', res.data.nickName ? res.data.nickName : res.data.phone);
				// 		this.$queue.setData('gender', parseInt(res.data.gender));
				// 		uni.switchTab({
				// 			url: '/pages/index/index'
				// 		});
				// 	} else {
				// 		uni.showModal({
				// 			showCancel: false,
				// 			title: '登录失败',
				// 			content: res.msg
				// 		});
				// 		this.$queue.logout();
				// 	}
				// 	uni.hideLoading();
				// });
			}
		}
	};
</script>

<style lang="scss" >
	page {
		background: #ffffff;
	}

	.footer {
		display: flex;
		justify-content: center;
		align-items: center;
		font-weight: 400;
		font-size: 24rpx;
		color: #333333;
		position: absolute;
		left: 0;
		right: 0;
		bottom: 78rpx;
		.cuIcon::before{
			width: 30rpx;
			height: 30rpx;
			margin-right: 12rpx;
		}
		.cuIcon-round::before {
			content: "\e6d7";
		}
		.cuIcon-radiobox:before {
			content: "\e75b";
			color: #37A6FF;
		}
	}

	.send-msg {
		line-height: initial;
		font-weight: 400;
		font-size: 28rpx;
		color: #EC6F48;
		border: none;
		background-color: transparent;
	}
	.send-msg::after{
		border: none;
		background-color: transparent;
	}
	
	.container {
		position: relative;
		width: 100%;
		height: 100%;
		overflow: hidden;
		background: #ffffff;
		box-sizing: border-box;
	}

	.wrapper {
		min-height: 100vh;
		position: relative;
		z-index: 90;
	}

	.input-content {
		padding: 0 56rpx;
	}
	.cu-form-group{
		display: flex;
		flex-direction: column;
		align-items: flex-start;
		margin-bottom: 48rpx;
		background-color: transparent;
		padding: 0;
		.title{
			margin-bottom: 32rpx;
			font-weight: 400;
			font-size: 28rpx;
			color: #333333;
		}
		.input{
			width: 100%;
			background-color: #fff;
			padding: 22rpx 32rpx 22rpx 24rpx;
		}
	}

	.confirm-btn {
		width: 100%;
		height: 100rpx;
		text-align: center;
		line-height: 100rpx;
		border-radius: 16rpx;
		margin-top: 80rpx;
		background: #EC6F48;
		font-size: 32rpx;
		color: #FFFFFF;

		&:after {
			border: none;
		}
	}
</style>